#2349 closed enhancement (fixed)

Timecounter: Add PPS support

Reported by: Sebastian Huber Owned by: Sebastian Huber <sebastian.huber@…>
Priority: normal Milestone: 6.1
Component: score Version:
Severity: normal Keywords:
Cc: Blocked By:
Blocking:

Description

The FreeBSD timecounter implementation supports the RFC 2783 PPS-API. This support is currently disabled in RTEMS.

Change History (19)

comment:1 Changed on 08/14/17 at 00:08:39 by Chris Johns

Milestone: 5.0Indefinite
Version: 4.11

comment:2 Changed on 05/23/22 at 07:02:19 by Sebastian Huber

Milestone: Indefinite6.1

comment:3 Changed on 05/23/22 at 07:04:29 by Gabriel Moyano <gabriel.moyano@…>

In 9b4212c7/rtems:

kern_ntptime.c: Disable freebsd features

Update #2349.

comment:4 Changed on 05/23/22 at 07:04:31 by Gabriel Moyano <gabriel.moyano@…>

In a3930e8c/rtems:

kern_ntptime.c: Add lmax() qmin() definitions

Update #2349.

comment:5 Changed on 05/23/22 at 07:04:34 by Gabriel Moyano <gabriel.moyano@…>

In bf61753a/rtems:

kern_tc.c: Add atomic dependencies required by the PPS API

Update #2349.

comment:6 Changed on 05/23/22 at 07:04:36 by Gabriel Moyano <gabriel.moyano@…>

In 95c747d9/rtems:

kern_tc.c: Replace FreeBSD event mechanism by adding pointers to function

Update #2349.

comment:7 Changed on 05/23/22 at 07:04:39 by Gabriel Moyano <gabriel.moyano@…>

In ac4ea53/rtems:

score: Rename tc_getfrequency()

Rename tc_getfrequency() to _Timecounter_Get_frequency().

Update #2349.

comment:8 Changed on 05/23/22 at 07:04:41 by Gabriel Moyano <gabriel.moyano@…>

In c34d3ae/rtems:

kern_tc.c: Add definitions required by PPS API

Update #2349.

comment:9 Changed on 05/23/22 at 07:04:43 by Gabriel Moyano <gabriel.moyano@…>

In 13513b81/rtems:

kern_tc.c: Enable PPS API support

Update #2349.

comment:10 Changed on 05/23/22 at 07:04:45 by Gabriel Moyano <gabriel.moyano@…>

In b304603b/rtems:

kern_ntptime.c: Add define in order to remove warning

Update #2349.

comment:11 Changed on 05/23/22 at 07:04:48 by Gabriel Moyano <gabriel.moyano@…>

In b3e4f58/rtems:

timepps.h: PPS_SYNC defined by default

Update #2349.

comment:12 Changed on 05/23/22 at 07:04:50 by Gabriel Moyano <gabriel.moyano@…>

In 5ccf960/rtems:

timecounter.h: Add _Timecounter_Discipline()

Update #2349.

comment:13 Changed on 05/23/22 at 07:04:52 by Gabriel Moyano <gabriel.moyano@…>

In 6553bf4/rtems:

testsuites/sptests: Add sppps01 test

Update #2349.

comment:14 Changed on 05/23/22 at 07:04:54 by Sebastian Huber <sebastian.huber@…>

Owner: set to Sebastian Huber <sebastian.huber@…>
Resolution: fixed
Status: newclosed

In 495f836/rtems:

score: Reformat for code coverage

Close #2349.

comment:15 Changed on 05/27/22 at 09:25:53 by Sebastian Huber <sebastian.huber@…>

In 044e8b6/rtems:

score: Fix pps_fetch()

Return early only if there was a timeout, otherwise return the PPS info.

Update #2349.

comment:16 Changed on 05/27/22 at 11:37:42 by Gabriel Moyano <gabriel.moyano@…>

In 34ba0e5a/rtems:

sppps01: Improve default handler test

Update #2349.

comment:17 Changed on 06/10/22 at 09:06:14 by Gabriel Moyano <gabriel.moyano@…>

In 11621c9c/rtems:

kern_tc.c: Update pps_event() for uniprocessor configurations

Since pps->capgen equal to zero is not a special value in uniprocessor configurations, there is no need to check for this condition.

Update #2349

comment:18 Changed on 06/23/22 at 07:42:35 by Sebastian Huber <sebastian.huber@…>

In 94df3a7a/rtems:

kern_tc.c: Provide a weak hardpps() implementation

The real implementation of hardpps() is defined in kern_ntptime.c. Use it only
if the NTP support is needed by the application.

Update #2349.

comment:19 Changed on 07/05/22 at 13:10:33 by Gabriel Moyano <gabriel.moyano@…>

In eefaf068/rtems:

sppps01: Add test case for early returns of pps_event()

Update #2349.

Note: See TracTickets for help on using tickets.